#!/usr/bin/python
'''
    How to run against a clean schroot named 'gutsy' (use a blank password for
    mysql-server):
        schroot -c gutsy -u root -- sh -c 'apt-get -y install mysql-server-5.0 mysql-client-5.0 && sudo ./test-mysql.py -v'

    TODO:
        - more thorough SQL (currently just do the mysql section from:
          https://wiki.ubuntu.com/Testing/Cases/ServerInstall
'''

import unittest, subprocess, os, sys, shutil
import testlib

class MySQLTest(testlib.TestlibCase):
    '''Test MySQL server functionality.'''

    def setUp(self):
        '''Setup mechanisms'''
	# let's shut it down
        subprocess.call(['/etc/init.d/mysql', 'stop'], stdout=subprocess.PIPE, stderr=subprocess.STDOUT)

	# and start it up again
        assert subprocess.call(['/etc/init.d/mysql', 'start'], stdout=subprocess.PIPE, stderr=subprocess.STDOUT) == 0

    def tearDown(self):
        '''Shutdown methods'''
        subprocess.call(['/etc/init.d/mysql', 'stop'], stdout=subprocess.PIPE, stderr=subprocess.STDOUT)

    def test_sql(self):
        '''Test MySQL server with sql file'''
	handle, name = testlib.mkstemp_fill('show databases;\nconnect mysql;\nshow tables;\nselect * from user;\n')

	self.assertShellExitEquals(0, ['/usr/bin/mysql'] + ['--no-defaults','-u','root','-h','localhost'], stdin=handle)

	os.unlink(name)

if __name__ == '__main__':
    unittest.main()
